use eframe::egui::{Response, Ui, Widget};

use super::state::AppState;

pub struct PromptInput<'a> {
    app_state: &'a mut AppState,
}

impl<'a> PromptInput<'a> {
    pub fn new(app_state: &'a mut AppState) -> Self {
        Self { app_state }
    }
}

impl<'a> Widget for PromptInput<'a> {
    fn ui(self, ui: &mut Ui) -> Response {
        ui.horizontal(|ui| {
            let label = ui.label("Prompt:");
            ui.text_edit_singleline(&mut self.app_state.prompt_input)
                .labelled_by(label.id);

            if ui.button("Submit").clicked() {
                self.app_state.prompt_input.clear();
            }
        });

        ui.label(&self.app_state.prompt_input)
    }
}
